#include "/home/xiongtao/bin/armadillo/mex_interface/armaMex.hpp"
#include "mex.h" 
#include "iostream"
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    if (nrhs != 1)
        mexErrMsgTxt("Incorrect number of input arguments");
    
    if ((mxGetClassID(prhs[0]) != mxDOUBLE_CLASS))
        mexErrMsgTxt("Input must be of type double.");
    
    if ((mxIsComplex(prhs[0]))) 
        mexErrMsgTxt("Input must be real.");
        
    Mat<double> f0 = armaGetData<double>(prhs[0]);
    Mat<double> f = f0;
    //cout << f << endl;
   
    int fn = f.n_rows;
    int fp = f.n_cols;

    Mat<double> v(fn, fp);
    v = v.zeros();;
   
    for (int i = 0; i < 2; ++i){ 
        
        int n = f.n_rows;
        int p = f.n_cols;
        Mat<int> s_size;
        s_size << n << p << endr;

        //cout << s_size << endl;
        
        //cout << s_size(i) << endl;
        // x = conv_to<Mat<int> >::from(linspace<vec>(1, s_size(i), s_size(i)));
       
        Mat<double> g(n, p);
        //cout << h << endl;
        
        //cout << f << endl;
        //cout << diff(f.rows(1, n - 1)) << endl;
        g.rows(1, n - 2) = (diff(f.rows(1, n - 1)) - diff(f.rows(0, n - 2))) / 2.0;
        if (n > 3){
            g.row(0) = g.row(1) * 2.0 - g.row(2);
            g.row(n - 1) = - g.row(n - 3) + g.row(n - 2) * 2.0;
        }
        else{
            if (n == 3){
                g.row(0) = g.row(1);
                g.row(n-1) = g.row(1);
            }
            else{
                g.row(0) = 0;
                g.row(n - 1) = 0;
            }
        }
        //cout << g << endl;
        //cout << i << endl;
        if (i == 0){
            //cout << v << endl;
            v = v + g;
            //cout << f << endl;
            f = trans(f);
            //cout << f.row(1) << endl;
            //cout << diff(f) << endl;

            g = g.zeros();
            }
        else{
            //cout << g << endl;
            v = v + (g.t());
        }
        
        //cout << v << endl;
           
    }
    v = v / 2.0;

	plhs[0] = armaCreateMxMatrix(fn, fp);
    armaSetData(plhs[0], v);
    return;                   
}			
				
				

			
				
	
