function [f] = gaussian_kernel(sigma)
  % 2013-04-01 tebuck: now all dimensions of output are odd-sized.

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu




  if numel(sigma) == 1
    sigma = ones(1, 3) * sigma;
  end

  s = ceil(sigma * 3.) * 2 + 1;
  % [cx, cy, cz] = meshgrid(1:s, 1:s, 1:s);
  [cx, cy, cz] = meshgrid(1:s(1), 1:s(2), 1:s(3));
  m = (s + 1) / 2;
  f = zeros(size(cx));
  % f = reshape(mvnpdf([cx(:), cy(:), cz(:)], ceil(size(cx)/2), diag(ones(1, 3) * sigma).^2), size(cx));
  % f = reshape(mvnpdf([cx(:), cy(:), cz(:)], ceil(size(cx)/2), diag(sigma).^2), size(cx));
  f = reshape(mvnpdf([cx(:), cy(:), cz(:)], m, sigma.^2), size(cx));
  f = f ./ sum(f(:));
  
  % % Debugging:
  % a = zeros(size(cx));
  % a(m(2) + (-1:1), m(1) + (-1:1), m(3) + (-1:1)) = 1;
  % imshow(reshape_contrast(a)), pause
  % imshow(reshape_contrast(f)), pause
