function [value] = image_central_moment(image, p, q, center)

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu



  %fprintf('image_central_moment\n')
  %center
  [h, w] = size(image);
  if ~exist('center', 'var') || isempty(center)
    m00 = image_moment(image, 0, 0);
    m10 = image_moment(image, 1, 0);
    m01 = image_moment(image, 0, 1);
    center = [m10 / m00, m01 / m00];
  else
    center = center ./ [w, h];
  end
  %center
  
  value = sum(((1:h) ./ h - center(2)).^q * image, 1);
  value = value * (((1:w) ./ w - center(1)).^p)';
