function [value] = image_major_axis(image, center)

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu




  if ~exist('center', 'var')
    center = [];
  end
  
  mu11 = image_central_moment(image, 1, 1, center);
  mu20 = image_central_moment(image, 2, 0, center);
  mu02 = image_central_moment(image, 0, 2, center);
% $$$   value = .5 * atan2(2 * mu11 / mu00, mu20 / mu00 - mu02 / mu00);
  value = .5 * atan2(2 * mu11, mu20 - mu02);
    
  
  
