function [t_cell_info] = master_script_model_p_value_csv_file(t_cell_info, options)
% Author: Xiongtao Ruan
% Data: 2015  master_script_options = t_cell_info.options;
% 2016/03/14 change to make it good into the pipeline. 

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu



master_script_options = t_cell_info.options;
models_location = t_cell_info.path_info.models_location;
model_prefix = master_script_options.model_prefix;

enrichment_statistics = load([models_location, sprintf('%senrichment_statistics.mat', model_prefix)]);

current_enrichment_type = enrichment_statistics.enrichment_types{1};

sensors = enrichment_statistics.sensors;

t_test_p_values = [enrichment_statistics.combination_enrichment_tests.t_test_p_value];

rounded_time = enrichment_statistics.all_relative_times_seconds_rounded;

p_values_cell = {};

p_values_cell{1, 1} = [];

p_values_cell(1, 1 + 1 : 1 + length(rounded_time)) = num2cell(rounded_time);

p_values_cell(2 : 1 + length(sensors), 1) = sensors;

p_values_cell(2 : 1 + length(sensors) , 1 + 1 : 1 + length(rounded_time)) = num2cell(reshape(t_test_p_values', length(rounded_time), [])');

csv_field_matrix = p_values_cell
%fid = fopen([models_location, 'model_cell_frame_count.csv'], 'wt');
fid = fopen([models_location, sprintf('%senrichment_statistics_mdl-type_standardized_voxels_enr-type_%s_p_values.csv', model_prefix, current_enrichment_type)], 'wt');
for i = 1:size(csv_field_matrix, 1)
    for j = 1:size(csv_field_matrix, 2)
        if j > 1
            fprintf(fid, ',');
        end
        if isempty(csv_field_matrix{i,j})
            fwrite(fid, '');
        elseif ischar(csv_field_matrix{i, j})
          fwrite(fid, csv_field_matrix{i, j});
        else
            if i == 1
                fprintf(fid, '%f', csv_field_matrix{i, j});
            else
                fprintf(fid, sprintf('%.2e', csv_field_matrix{i, j}));
            end
       end      
    end
    fprintf(fid, '\n');
end
fclose(fid);
%save([models_location, 'model_cell_frame_count.mat'], 'cell_frame_count');

end