function [b] = reshape_contrast(a, r, is_vector_field)
  % Convenience function to apply contrast_stretch to a before applying reshape_2d.

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu




  if ~exist('r', 'var') || isempty(r)
    r = 1;
  end
  if ~exist('is_vector_field', 'var') || isempty(is_vector_field)
    is_vector_field = false;
  end
  if is_vector_field
    maximum_absolute_value = max(abs(a(:)));
    for index = 1:3
      b(:, :, index) = reshape_2d(a(:, :, :, index), r);
      b(:, :, index) = contrast_stretch_about_zero(b(:, :, index));
    end
  else
    b = a;
    b = contrast_stretch(b);
    b = reshape_2d(b, r);
  end
