function [] = start_job_diary(base_filename)

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu




  pbs_job_id = getenv('PBS_JOBID');
  pbs_job_id = regexprep(pbs_job_id, '[\r\n]', '');
  if isempty(pbs_job_id)
    pbs_job_id = '';
  end
  date_text = datestr(now(), 'yyyymmddHHMMSSFFF')
  % This might be called by other functions, so don't start a diary in such cases in case the calling functions have already done so:
  diary([base_filename, 'log', date_text, '_', pbs_job_id, '.txt']);
end
