function [result] = struct_ismember(a, b)
% Simple clone of ismember for structures.
% 
% Tests:
% struct_ismember([struct('a', 2), struct('a', 3)], [struct('a', 1), struct('a', 2), struct('a', 3)])
% struct_ismember([struct('a', 2), struct('a', 4)]', [struct('a', 1), struct('a', 2), struct('a', 3)])
% 
% Dependencies:
% From the File Exchange:
% cellstructeq <http://www.mathworks.com/matlabcentral/fileexchange/27542-compare-nested-cell-struct-arrays-recursively>

%
% Author: Taraz E. Buck and Xiongtao Ruan
%
% Copyright (C) 2012-2016 Murphy Lab
% Computational Biology Department
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu



  % a, b, pause
  
  result = false(size(a));
  for a_index = 1:numel(a)
    for b_index = 1:length(b)
      % a(a_index), b(a_index)
      % structeq(a(a_index), b(b_index))
      if structeq(a(a_index), b(b_index))
        result(a_index) = true;
        break
      end
    end
  end

