import re, os, time, sys, random
from openpyxl import load_workbook
import csv
import string
import shutil
import errno


def xlsx2csv_converter(xlsx_file = '/media/SDA3/coordinates 5C.C7 LAT 02 03 15.xlsx', csv_file = '/media/SDA3/coordinates 5C.C7 LAT 02 03 15.csv'):
    print xlsx_file
    print csv_file
    wb = load_workbook(filename = xlsx_file)
    ws = wb.active
    #print(ws['D18'].value)
    letter_list = string.uppercase[:11]

    end_flag = 0
    sheet_list = []
    for i in range(1000):
        row_i = [];
        blank_flag = 1
        for il in letter_list:
            iil_value = ws[il + str(i + 1)].value
            row_i.append(iil_value)
            if iil_value != None:
                blank_flag = 0
                
        sheet_list.append(row_i)
        
        if blank_flag:
            end_flag += 1
        else:
            end_flag = 0

        if end_flag >= 5:
            break
    #print sheet_list

    csv_list = [];
    # For new LAT annotation files, it is a bit different from the old one in terms of organization. 
    #xlsx : Distance	Angle	Left	Top	Width	Height	relative time	abslute time	coordinates
    #csv : Region Label	Distance	Angle	Left	Top	Width	Height		time to onset 	cell coordinate	onset time	absolute time

    title_string = 'Region Label	Distance	Angle	Left	Top	Width	Height		relative time 	coordinates	onset time	absolute time';
    title_list = title_string.split('\t')
    csv_list.append(title_list)

    if sheet_list[0][0] == 'Distance':
        sheet_list_adjust = []
        sheet_list_adjust.append(title_list)
        for j in range(1, len(sheet_list)):
            value_flag = 0
            for value in sheet_list[j]:
                if value != None:
                    value_flag = 1
                    break
            if value_flag:
                sheet_list_adjust.append(['Line1'] + sheet_list[j][:-1])
            else:
                sheet_list_adjust.append(sheet_list[j])
        sheet_list = sheet_list_adjust

    # adjust for file  LATVav anti-B7 150518.xlsx
    print xlsx_file
    if re.search('LATVav anti-B7 150518.xlsx', xlsx_file) is not None:
        print '15123408945'
        for i in range(len(sheet_list)):
            print sheet_list[i]
            sheet_list[i] = sheet_list[i][:7] + sheet_list[i][8:]
        print sheet_list        
    
    can_start = 0
    for i in range(len(sheet_list) - 5):                    
        if not can_start:      
            if sheet_list[i][0] != 'Region Label':
                continue
            else:
                can_start = 1
                continue
                
            
        row_i = sheet_list[i]
        # print row_i
        csv_row_i = []
        if row_i[1] != None:
            csv_row_i.append(row_i[0][-1])
        else:
            csv_row_i.append(None)
        # print row_i
        # print csv_row_i
        csv_row_i.extend(row_i[1 : 7])
        csv_row_i.append('')                         
        csv_row_i.append(row_i[7])

        if row_i[9] != None:
            # print row_i[9]
            coordinate_onset = str(row_i[9]).split('@')
            # print coordinate_onset
            if len(coordinate_onset) == 2:
                coordinate_onset[0] = ', '.join(coordinate_onset[0].split(','))
                csv_row_i.extend(coordinate_onset)
            # the below cases may be not right for these xlsx files. But the above is enough for all xlsx files in this dataset.     
            elif isinstance(row_i[9], int):
                csv_row_i.append(row_i[9])
                csv_row_i.append(row_i[9] - row_i[8])
            else: 
                #csv_row_i.append(row_i[10])
                csv_row_i.append(None)
                csv_row_i.append(None)
        else:
            csv_row_i.extend([None, None])
        # print csv_row_i    
        csv_row_i.append(row_i[8])
        if csv_row_i[8] == 'late':
            csv_row_i = [None] * 12

        value_flag = 0
        for j in range(7) + [8, 11]:
            #print len(csv_row_i)
            if csv_row_i[j] != None:
                value_flag += 1
                break
        if value_flag < 8 and value_flag > 0:
            for j in range(7) + [8, 11]:
                if csv_row_i[j] == None:
                    csv_row_i[j] = 'NA'

        csv_list.append(csv_row_i)

    fid = open(csv_file, "wb")
    c = csv.writer(fid)
        
    for row in csv_list:
        #print row
        c.writerow(row)
        fid.flush()
    fid.close()
    return 1

def csv_file_name_get(xlsx_root_dir = '/media/SDA3/images/wuelfing2015_organized'):

    # Jan. 17, 2016 add code to adapt to new LAT data
    # print condition_dir_list
    new_LAT_flag = True
    xlsx_csv_dict = {}
    condition_dir_list = os.listdir(xlsx_root_dir)
    if not condition_dir_list:
        print 'there is no file in the directory'
        return 0
    for condition_dir in condition_dir_list:
        condition_path = xlsx_root_dir + '/' + condition_dir
        protein_dir_list = os.listdir(condition_path)
        if not protein_dir_list:
            print 'there is no file in the directory'
            continue      
        for protein_dir in protein_dir_list:
            protein_path = '/'.join([condition_path, protein_dir])
            print protein_dir
            #if new_LAT_flag == True:
            #    protein_path = condition_path
            #    print protein_path
            date_dir_list = os.listdir(protein_path)
            if not date_dir_list:
                print 'there is no file in the directory'
                continue
            for date_dir in date_dir_list:
                date_path = '/'.join([protein_path, date_dir])
                run_dir_list = os.listdir(date_path)
                if not run_dir_list:
                    print 'there is no file in the directory'
                    continue
                # print run_dir_list
                for run_dir in run_dir_list:
                    run_path = '/'.join([date_path, run_dir])
                    file_list = os.listdir(run_path)
                    if not file_list:
                        print 'there is no file in the directory'
                        continue
                    # print file_list
                    for file_name in file_list:
                        full_path = '/'.join([xlsx_root_dir, condition_dir, protein_dir, date_dir, run_dir, file_name])                            
                        if os.path.isfile(full_path):
                            if file_name[-4 : ] == 'xlsx':
                                xlsx_file = full_path
                                # print xlsx_file
                                csv_file_short = ''.join([condition_dir, '_', protein_dir, '_', date_dir[6 :], ' ', run_dir, '.csv'])
                                if new_LAT_flag == True:
                                    # change names, add Actin Regulators.
                                    csv_file_short = ''.join([condition_dir[0:5], ' Actin Regulators -', condition_dir[5:], '_', 'LAT', '_', date_dir[6 :], ' ', run_dir, '.csv'])
                                xlsx_csv_dict[xlsx_file] = csv_file_short
                                print xlsx_file
                                print csv_file_short
                                continue
                         
    return xlsx_csv_dict
                                
                            

def main():
    xlsx_root_dir = '/projects/images/new_LAT_images_organized'                                                     
    xlsx_csv_dict = csv_file_name_get(xlsx_root_dir)
    print xlsx_csv_dict
    # csv_root_dir = '/media/SDA3/All coordinates two-point 2015'
    csv_root_dir = '/projects/All coordinates two-point 2015 new LAT'
    csv_subdir = csv_root_dir + '/Converted to CSV'
    original_subdir = csv_root_dir + '/Original'
    if os.path.exists(csv_root_dir) == False:
        os.mkdir(csv_root_dir)
    if os.path.exists(csv_subdir) == False:
        os.mkdir(csv_subdir)
    if os.path.exists(original_subdir) == False:
        os.mkdir(original_subdir)
    for xlsx_file, csv_file_short in xlsx_csv_dict.iteritems():
        xlsx_file_path_sep = xlsx_file.split('/')
        original_file_path = original_subdir + '/' + '/'.join(xlsx_file_path_sep[5 : -1])
        if ~os.path.exists(original_file_path):
            try:
                os.makedirs(original_file_path)
            except OSError as exception:
                if exception.errno != errno.EEXIST:
                    raise
        shutil.copy(xlsx_file, original_file_path)
        csv_full_path = csv_subdir + '/' + csv_file_short
        xlsx2csv_converter(xlsx_file, csv_full_path)
        
                                                         

if __name__ == '__main__':
    main()

